<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <title>Title</title>
</head>
<body>
<table summary="Content" id="sitecontent" width="100%" cellpadding="0" cellspacing="0" border="0">
    <tbody>
    <tr>
        <td>
            <!--PageText-->
            <div id="wikitext">
                <h1>Cvičení Filipa Vencovského ZS 2021/2022</h1>
                <h2>Důležité odkazy</h2>
                <ul>
                    <li>Školní úložiště projektů <a class="urllink" href="https://gitlab.com/FIS-VSE" rel="nofollow">https://gitlab.com/FIS-VSE</a>
                    </li>
                    <li>Elektronická skripta <a class="urllink"
                                                href="https://oeconomica.vse.cz/wp-content/uploads/page/17086/Vencovsky_EBOOK_2019.pdf"
                                                rel="nofollow">Nástroje pro tvorbu, správu a nasazování aplikací</a>
                    </li>
                    <li>Screencasty k předmětu na <a class="urllink"
                                                     href="https://www.youtube.com/channel/UC_vr1HZYLlPGNIVYLPfhA9w"
                                                     rel="nofollow">YouTube 4IT115 - Softwarové inženýrství</a>
                    </li>
                    <li>Obecné požadavky na ukončení předmětu na <a class="urllink"
                                                                    href="https://java.vse.cz/4it115/4it115"
                                                                    rel="nofollow">https://java.vse.cz/4it115/4it115</a>
                    </li>
                </ul>
                <div class="vspace"></div>
                <h2>Odkazy pro stažení softwaru</h2>
                <ul>
                    <li>IntelliJ IDEA - licence <a class="urllink"
                                                   href="https://www.jetbrains.com/community/education/#students"
                                                   rel="nofollow">https://www.jetbrains.com/community/education/#students</a>,
                        program <a class="urllink" href="https://www.jetbrains.com/idea/" rel="nofollow">https://www.jetbrains.com/idea/</a>
                    </li>
                    <li>Git <a class="urllink" href="http://git-scm.com/downloads" rel="nofollow">http://git-scm.com/downloads</a>
                    </li>
                    <li>Scene Builder <a class="urllink" href="https://gluonhq.com/products/scene-builder/"
                                         rel="nofollow">https://gluonhq.com/products/scene-builder/</a>
                    </li>
                </ul>
                <div class="vspace"></div>
                <h2>Harmonogram cvičení </h2>
                <table border="1" cellpadding="5" width="600">
                    <tbody>
                    <tr>
                        <th align="left">Týden</th>
                        <th align="left">Obsah cvičení</th>
                    </tr>
                    <tr>
                        <td align="center">1</td>
                        <td align="left">Obsah a harmonogram předmětu, požadavky na ukončení předmětu, seznámení práce s
                            vývojovým prostředím IDEA <br clear="all"> převedení projektu Adventura základ z BlueJ do
                            IDE
                        </td>
                    </tr>
                    <tr>
                        <td align="center">2</td>
                        <td align="left">Seznámení se správou verzí Git, nahrání projektu na GitLab</td>
                    </tr>
                    <tr>
                        <td align="center">3</td>
                        <td align="left">Architektura Java FX aplikace, Scene Builder</td>
                    </tr>
                    <tr>
                        <td align="center">4</td>
                        <td align="left">Základní java FX komponenty</td>
                    </tr>
                    <tr>
                        <td align="center">5</td>
                        <td align="left">Návrhový vzor Observer</td>
                    </tr>
                    <tr>
                        <td align="center">6</td>
                        <td align="left">Java FX komponenty</td>
                    </tr>
                    <tr>
                        <td align="center">7</td>
                        <td align="left">Obhajoby semestrálních prací</td>
                    </tr>
                    <tr>
                        <td align="center">8</td>
                        <td><strong>Vytvoření týmů a přiřazení zadání pro 2. semestrální úlohu</strong></td>
                    </tr>
                    <tr>
                        <td align="center">9</td>
                        <td align="left">Návrh týmové úlohy</td>
                    </tr>
                    <tr>
                        <td align="center">10</td>
                        <td align="left">Tvorba protoypu aplikace</td>
                    </tr>
                    <tr>
                        <td align="center">11</td>
                        <td align="left">Práce se soubory a databází</td>
                    </tr>
                    <tr>
                        <td align="center">12</td>
                        <td align="left"><strong>Odevzdání návrhu</strong></td>
                    </tr>
                    <tr>
                        <td align="center">13</td>
                        <td align="left"><strong>Obhajoba návrhu a inspekce</strong></td>
                    </tr>
                    </tbody>
                </table>
                <p class="vspace">* Změna ze standardního čtvrtečního opakování na středu v jiný čas. Protože čas
                    cvičení nemusí všem vyhovovat, náplní budou obhajoby semestrálních prací, na které je třeba se
                    předem přihlásit v insisu.
                </p>
                <div class="vspace"></div>
                <h2>Samostatná práce v průběhu semestru</h2>
                <table border="1" cellpadding="5" width="600">
                    <tbody>
                    <tr>
                        <th align="left">Název</th>
                        <th>Body</th>
                    </tr>
                    <tr>
                        <td align="left">Aktivita na cvičení</td>
                        <td align="center">8</td>
                    </tr>
                    <tr>
                        <td align="left">Individuální UML model</td>
                        <td align="center">5</td>
                    </tr>
                    <tr>
                        <td align="left">Aktivita (#help na Teamsech)</td>
                        <td align="center">2</td>
                    </tr>
                    <tr>
                        <td align="left"><strong>Celkem</strong></td>
                        <td align="center"><strong>15</strong></td>
                    </tr>
                    </tbody>
                </table>
                <div class="vspace"></div>
                <h2>1. semestrální úloha</h2>
                <p>Termín odevzdání:
                </p>
                <ul>
                    <li>do konce 8. týdne (14. 11. 2021) - posunuto z 31. 10. 2021 🎃🧛⚰️🫀🕸️🧟👻
                    </li>
                </ul>
                <p class="vspace">Obecné požadavky:
                </p>
                <ul>
                    <li><a class="urllink" href="https://java.vse.cz/4it115/ZadaniPrvniUlohy" rel="nofollow">https://java.vse.cz/4it115/ZadaniPrvniUlohy</a>
                    </li>
                </ul>
                <p class="vspace">Body za 1. semestrální úlohu získá student pouze, pokud splní následující podmínky:
                </p>
                <ol>
                    <li>Založí projekt ve své skupině <strong>ve školním úložišti</strong> na GitLab.com s názvem dle
                        vašeho xname (školní ID): <em>xname</em>-adventura-sem (viz <a class="urllink"
                                                                                       href="https://java.vse.cz/4it115/GitLab"
                                                                                       rel="nofollow">https://java.vse.cz/4it115/GitLab</a>)
                    </li>
                    <li>V projektu vytvoří <strong>ve třetím týdnu</strong> větev <em>textovaVerze</em> s výchozí verzí
                        úlohy.
                    </li>
                    <li>Bude <strong>postupně</strong> commitovat změny ve větvi <em>dev</em>.
                    </li>
                    <li>V hlavní větvi <em>master</em> bude mít hotovou úlohou, kterou <strong>označí štítkem
                        1.0.0</strong>.
                    </li>
                    <li><strong>Obhájí program</strong>. Při obhajobě student předvede funkci programu, vysvětlí
                        jakoukoli část kódu a provede na místě úpravu programu podle požadavků vyučujícího.
                    </li>
                </ol>
                <p class="vspace">Upřesnění požadavků na 1.semestrální úlohu - GUI adventura:
                </p>
                <div class="vspace"></div>
                <table border="1" cellpadding="6" width="70%">
                    <tbody>
                    <tr>
                        <th align="left">Požadavek</th>
                        <th align="left">Bodové ohodnocení</th>
                    </tr>
                    <tr>
                        <td align="left">Základem je adventura s textovým uživatelským rozhraním, kterou jste odevzdali
                            v kurzu 4IT101, dostupná jako aktivní větev <strong>textovaVerze</strong></td>
                        <td align="left">musí být<sup>2</sup></td>
                    </tr>
                    <tr>
                        <td align="left">Třídy aplikace budou rozděleny do balíčků</td>
                        <td align="left">musí být<sup>2</sup></td>
                    </tr>
                    <tr>
                        <td align="left">Hlavní okno grafického rozhraní bude obsahovat textovou oblast<sup>1</sup>, ve
                            které se budou vypisovat jednotlivé texty hry
                        </td>
                        <td align="left">musí být<sup>2</sup></td>
                    </tr>
                    <tr>
                        <td align="left">Pro vstup příkazů bude využito textové pole<sup>1</sup></td>
                        <td align="left">musí být<sup>2</sup></td>
                    </tr>
                    <tr>
                        <td align="left">Součástí grafického rozhraní musí být MenuBar, které bude obsahovat minimálně
                            položky Nová hra, Nápověda
                        </td>
                        <td align="left">musí být<sup>2</sup></td>
                    </tr>
                    <tr>
                        <td align="left">Při přechodu do prostoru se na panelu<sup>1</sup> vypíší východy z prostoru,
                            realizováno pomocí návrhového vzoru Observer
                        </td>
                        <td align="left">musí být<sup>2</sup></td>
                    </tr>
                    <tr>
                        <td align="left">Hra obsahuje plán prostorů, na kterém bude vyznačena aktuální poloha,
                            realizováno pomocí návrhového vzoru Observer
                        </td>
                        <td align="left">musí být<sup>2</sup></td>
                    </tr>
                    <tr>
                        <td align="left">Nápověda (uložená v HTML souboru) se bude zobrazovat v samostatném okně FX
                            aplikace (nikoli jako odkaz do internetového prohlížeče)
                        </td>
                        <td align="left">musí být<sup>2</sup></td>
                    </tr>
                    <tr>
                        <td align="left">Na GitLab bude hotová úloha<sup>2</sup> označena štítkem 1.0.0</td>
                        <td align="left">musí být<sup>2</sup></td>
                    </tr>
                    <tr>
                        <td align="left">Obsah batohu se bude zobrazovat pomocí obrázků na panelu<sup>1</sup>, při změně
                            obsahu batohu se provede aktualizace obrázků, v řešení bude využit návrhový vzor Observer
                        </td>
                        <td align="left">musí být<sup>2</sup></td>
                    </tr>
                    <tr>
                        <td align="left">Aplikace se spustí buď v textovém rozhraní, anebo v grafickém rozhraní podle
                            parametru příkazové řádky
                        </td>
                        <td>pokud nebude implementováno -2 body</td>
                    </tr>
                    <tr>
                        <td align="left">Repozitář obsahuje integrační skript, který program automaticky sestaví na
                            GitLab.com
                        </td>
                        <td align="left">pokud nebude implementováno -2 body</td>
                    </tr>
                    <tr>
                        <td align="left">Komentáře pro javadoc u tříd a metod</td>
                        <td>pokud nebude implementováno -3 body</td>
                    </tr>
                    <tr>
                        <td>Zpoždění při odevzdání finální verze<sup>2</sup>, tj vytvoření štítku 1.0.0</td>
                        <td align="left">-3 body za každý započatý týden zpoždění</td>
                    </tr>
                    <tr>
                        <td align="left">Bonusové prvky dle uvážení</td>
                        <td align="left">body dle inovativnosti a náročnosti prvků</td>
                    </tr>
                    </tbody>
                </table>
                <p class="vspace"><sup>1</sup> Hra může využít i lepší způsob vstupu a zobrazování informací o průběhu
                    hry (viz bonusové prvky)
                </p>
                <p class="vspace"><sup>2</sup> Povinné požadavky jsou součástí finální verze. Datum odevzdání je možné
                    započítat až po splnění těchto požadavků. Není možné obajovat práci bez splění těchto požadavků.
                </p>
                <div class="vspace"></div>
                <h2>Zadání týmových projektů</h2>
                <ul>
                    <li>Bude zveřejněno na MS Teams
                    </li>
                </ul>
                <div class="vspace"></div>
                <h2>Odkazy pro správu kódu</h2>
                <ul>
                    <li>Kniha o Git v češtině <a class="urllink" href="https://git-scm.com/book/cs/v2" rel="nofollow">https://git-scm.com/book/cs/v2</a>
                    </li>
                    <li>Git Cheat Sheet <a class="urllink"
                                           href="https://education.github.com/git-cheat-sheet-education.pdf"
                                           rel="nofollow">https://education.github.com/git-cheat-sheet-education.pdf</a>
                    </li>
                    <li>Návody pro GitHub <a class="urllink" href="https://guides.github.com/" rel="nofollow">https://guides.github.com/</a>
                    </li>
                    <li>Návody pro Git pro Eclipse <a class="urllink" href="http://wiki.eclipse.org/EGit/User_Guide"
                                                      rel="nofollow">http://wiki.eclipse.org/EGit/User_Guide</a>
                    </li>
                    <li>Ukázky GitHub projektů v Javě <a class="urllink" href="https://github.com/topics/java"
                                                         rel="nofollow">https://github.com/topics/java</a>
                    </li>
                    <li>Konvence verzování <a class="urllink" href="https://semver.org/" rel="nofollow">https://semver.org/</a>
                    </li>
                </ul>
                <div class="vspace"></div>
            </div>

        </td>
    </tr>
    </tbody>
</table>
</body>
</html>